jQuery(document).ready(function($) {

	// Fancy Color Picker

	$.each($("input." + nnr_rp_widget_settings.prefix + "fancy-colors-selectize"), function(key, value){

		$('input.' + nnr_rp_widget_settings.prefix + 'fancy-colors-selectize.selectized').hide();

		if (!$(value).hasClass('selectized')) {
			$(value).selectize({
				plugins: ['drag_drop', 'remove_button'],
				valueField: 'hex',
			    labelField: 'name',
			    searchField: 'name',
			    options: [
			       	{hex: '#61BD6D', name: 'Fern'},
			        {hex: '#1ABC9C', name: 'Mountain Meadow'},
			        {hex: '#54ACD2', name: 'Picton Blue'},
			        {hex: '#2C82C9', name: 'Mariner'},
			        {hex: '#9365B8', name: 'Wisteria'},
			        {hex: '#457757', name: 'Chambray'},
			        {hex: '#41A85F', name: 'Chateau Green'},
			        {hex: '#00A885', name: 'Persian Green'},
			        {hex: '#3D8EB9', name: 'Curious Blue'},
			        {hex: '#2969B0', name: 'Denim'},
			        {hex: '#553982', name: 'Blue Gem'},
			        {hex: '#28324E', name: 'Blue Whale'},
			        {hex: '#F7DA64', name: 'Energy'},
			        {hex: '#FBA026', name: 'Neon Carrot'},
			        {hex: '#EB6B56', name: 'Terra Cotta'},
			        {hex: '#E14938', name: 'Cinnabar'},
			        {hex: '#A38F84', name: 'Almond Frost'},
			        {hex: '#EFEFEF', name: 'White Smoke'},
			        {hex: '#FAC51C', name: 'Turbo'},
			        {hex: '#F37934', name: 'Sun'},
			        {hex: '#D14841', name: 'Valencia'},
			        {hex: '#B8312F', name: 'Well Road'},
			        {hex: '#75706B', name: 'Iron Gray'},
			        {hex: '#D1D5D8', name: 'Iron'},
				],
			    onChange: function(){
				    $.each($(".selectize-input .item"), function(key, value){
						$(value).css('background-color', $(value).data('value'));

						if ($(value).data('value') == '#457757' ||
							$(value).data('value') == '#2969B0' ||
							$(value).data('value') == '#553982' ||
							$(value).data('value') == '#28324E' ||
							$(value).data('value') == '#75706B') {
							$(value).css('color', 'white');
						}
					});
			    },
			    render: {
				    option: function(data, escape) {

					    if (data.hex == '#457757' ||
							data.hex == '#2969B0' ||
							data.hex == '#553982' ||
							data.hex == '#28324E' ||
							data.hex == '#75706B') {
							return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
						}

					    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
				    },
				    item : function(data, escape) {

					    if (data.hex == '#457757' ||
							data.hex == '#2969B0' ||
							data.hex == '#553982' ||
							data.hex == '#28324E' ||
							data.hex == '#75706B') {
							return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
						}

					    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
				    }
			    }
			});
		}
	});

	$('div.widgets-sortables').bind('sortstop',function(event,ui){

		$.each($("input." + nnr_rp_widget_settings.prefix + "fancy-colors-selectize"), function(key, value){

			$('input.' + nnr_rp_widget_settings.prefix + 'fancy-colors-selectize.selectized').hide();

			if (!$(value).hasClass('selectized')) {
				$(value).selectize({
					plugins: ['drag_drop', 'remove_button'],
					valueField: 'hex',
				    labelField: 'name',
				    searchField: 'name',
				    options: [
				       	{hex: '#61BD6D', name: 'Fern'},
				        {hex: '#1ABC9C', name: 'Mountain Meadow'},
				        {hex: '#54ACD2', name: 'Picton Blue'},
				        {hex: '#2C82C9', name: 'Mariner'},
				        {hex: '#9365B8', name: 'Wisteria'},
				        {hex: '#457757', name: 'Chambray'},
				        {hex: '#41A85F', name: 'Chateau Green'},
				        {hex: '#00A885', name: 'Persian Green'},
				        {hex: '#3D8EB9', name: 'Curious Blue'},
				        {hex: '#2969B0', name: 'Denim'},
				        {hex: '#553982', name: 'Blue Gem'},
				        {hex: '#28324E', name: 'Blue Whale'},
				        {hex: '#F7DA64', name: 'Energy'},
				        {hex: '#FBA026', name: 'Neon Carrot'},
				        {hex: '#EB6B56', name: 'Terra Cotta'},
				        {hex: '#E14938', name: 'Cinnabar'},
				        {hex: '#A38F84', name: 'Almond Frost'},
				        {hex: '#EFEFEF', name: 'White Smoke'},
				        {hex: '#FAC51C', name: 'Turbo'},
				        {hex: '#F37934', name: 'Sun'},
				        {hex: '#D14841', name: 'Valencia'},
				        {hex: '#B8312F', name: 'Well Road'},
				        {hex: '#75706B', name: 'Iron Gray'},
				        {hex: '#D1D5D8', name: 'Iron'},
					],
				    onChange: function(){
					    $.each($(".selectize-input .item"), function(key, value){
							$(value).css('background-color', $(value).data('value'));

							if ($(value).data('value') == '#457757' ||
								$(value).data('value') == '#2969B0' ||
								$(value).data('value') == '#553982' ||
								$(value).data('value') == '#28324E' ||
								$(value).data('value') == '#75706B') {
								$(value).css('color', 'white');
							}
						});
				    },
				    render: {
					    option: function(data, escape) {

						    if (data.hex == '#457757' ||
								data.hex == '#2969B0' ||
								data.hex == '#553982' ||
								data.hex == '#28324E' ||
								data.hex == '#75706B') {
								return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
							}

						    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
					    },
					    item : function(data, escape) {

						    if (data.hex == '#457757' ||
								data.hex == '#2969B0' ||
								data.hex == '#553982' ||
								data.hex == '#28324E' ||
								data.hex == '#75706B') {
								return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
							}

						    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
					    }
				    }
				});
			}
		});
	});

	$('body').ajaxSuccess(function(evt, request, settings) {

		$.each($("input." + nnr_rp_widget_settings.prefix + "fancy-colors-selectize"), function(key, value){

			$('input.' + nnr_rp_widget_settings.prefix + 'fancy-colors-selectize.selectized').hide();

			if (!$(value).hasClass('selectized')) {
				$(value).selectize({
					plugins: ['drag_drop', 'remove_button'],
					valueField: 'hex',
				    labelField: 'name',
				    searchField: 'name',
				    options: [
				       	{hex: '#61BD6D', name: 'Fern'},
				        {hex: '#1ABC9C', name: 'Mountain Meadow'},
				        {hex: '#54ACD2', name: 'Picton Blue'},
				        {hex: '#2C82C9', name: 'Mariner'},
				        {hex: '#9365B8', name: 'Wisteria'},
				        {hex: '#457757', name: 'Chambray'},
				        {hex: '#41A85F', name: 'Chateau Green'},
				        {hex: '#00A885', name: 'Persian Green'},
				        {hex: '#3D8EB9', name: 'Curious Blue'},
				        {hex: '#2969B0', name: 'Denim'},
				        {hex: '#553982', name: 'Blue Gem'},
				        {hex: '#28324E', name: 'Blue Whale'},
				        {hex: '#F7DA64', name: 'Energy'},
				        {hex: '#FBA026', name: 'Neon Carrot'},
				        {hex: '#EB6B56', name: 'Terra Cotta'},
				        {hex: '#E14938', name: 'Cinnabar'},
				        {hex: '#A38F84', name: 'Almond Frost'},
				        {hex: '#EFEFEF', name: 'White Smoke'},
				        {hex: '#FAC51C', name: 'Turbo'},
				        {hex: '#F37934', name: 'Sun'},
				        {hex: '#D14841', name: 'Valencia'},
				        {hex: '#B8312F', name: 'Well Road'},
				        {hex: '#75706B', name: 'Iron Gray'},
				        {hex: '#D1D5D8', name: 'Iron'},
					],
				    onChange: function(){
					    $.each($(".selectize-input .item"), function(key, value){
							$(value).css('background-color', $(value).data('value'));

							if ($(value).data('value') == '#457757' ||
								$(value).data('value') == '#2969B0' ||
								$(value).data('value') == '#553982' ||
								$(value).data('value') == '#28324E' ||
								$(value).data('value') == '#75706B') {
								$(value).css('color', 'white');
							}
						});
				    },
				    render: {
					    option: function(data, escape) {

						    if (data.hex == '#457757' ||
								data.hex == '#2969B0' ||
								data.hex == '#553982' ||
								data.hex == '#28324E' ||
								data.hex == '#75706B') {
								return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
							}

						    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
					    },
					    item : function(data, escape) {

						    if (data.hex == '#457757' ||
								data.hex == '#2969B0' ||
								data.hex == '#553982' ||
								data.hex == '#28324E' ||
								data.hex == '#75706B') {
								return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
							}

						    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
					    }
				    }
				});
			}
		});
	});

	// Background Color Picker

	$('body').on('focus', '.bg-color-picker', function(){
		var parent = jQuery(this).parent();
        jQuery(this).wpColorPicker({
	        defaultColor: '#1e73be',
        });
        parent.find('.wp-color-result').click();
	});

	// Text Color Picker

	$('body').on('focus', '.color-picker', function(){
		var parent = jQuery(this).parent();
        jQuery(this).wpColorPicker({
	        defaultColor: '#000000',
        });
        parent.find('.wp-color-result').click();
	});

	// Numbered List Color Picker

	$('body').on('focus', '.nl-color-picker', function(){
		var parent = jQuery(this).parent();
        jQuery(this).wpColorPicker({
	        defaultColor: '#ffffff',
        });
        parent.find('.wp-color-result').click();
	});

	// Numbered List Box Color Picker

	$('body').on('focus', '.nl-circle-color-picker', function(){
		var parent = jQuery(this).parent();
        jQuery(this).wpColorPicker({
	        defaultColor: '#94cd4b',
        });
        parent.find('.wp-color-result').click();
	});

});